#!/usr/bin/python
# -*- coding: utf-8 -*-
# writter: bailiang
"""RTX的客户端

负责登录RTX服务器，随时接受服务器端特别的插件来提示有新的
信息   目标端口1051
实际功能类似聊天室
"""

__revision__ = '0.1'
import wx
import threading,re,socket
import  wx.lib.newevent
import ico

(UpdateBarEvent, EVT_UPDATE_BARGRAPH) = wx.lib.newevent.NewEvent()  # 创建一个自定义的wxpython事件

class ListenThread(threading.Thread):                            # 创建监听线程
    def __init__(self,win,server):
        threading.Thread.__init__(self)
        self.win = win
        self.server = server

    def run(self):                                    # 进入监听状态
        global RtxMessage
        while 1:                                # 使用while循环不停监听
            try:                                # 捕获异常
                client, addr = self.server.accept()              # 等待连接
                data = client.recv(1024)                # 接受数据
                try:
                    str= data.decode("gb2312").encode("utf8") #将win的内码转换成utf-8

                    #用正则表达式找出发信人和内容
                    vars=[]
                    m = re.compile(r'.*发送(?=<RTXCData>)',re.S|re.I|re.U)
                    vars.extend(m.findall(str))
                    m = re.compile(r'(?<=&lt;Txt&gt;).+?(?=&lt;/Txt&gt;)',re.S|re.I|re.U)
                    vars.extend(m.findall(str))
                    res = ':'.join(vars)
                except:
                    res ='到达的信息无法正常解析！'

                lock.acquire()              # 锁定全局变量，防止发生冲突
                RtxMessage = res            # 修改要显示的信息
                lock.release()
                evt = UpdateBarEvent()      # 实例化一个wx的信号
                wx.PostEvent(self.win,evt)  # 发送一个有新信息的信号

                client.send('ok')                # 发送应答数据
                client.close()                        # 关闭同客户端的连接
            except:                                # 异常处理
                global controlrun
                controlrun=False
                break                            # 结束循环
class Control(threading.Thread):                            # 控制线程
    def __init__(self,win):
        threading.Thread.__init__(self)
        self.win = win
        self.event = threading.Event()                        # 创建Event对象
        self.event.clear()                            # 清楚event标志
    def run(self):
        server = socket.socket(socket.AF_INET, socket.SOCK_STREAM)        # 创建socket连接
        server.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR,1)
        try:
            server.bind(('', 1051))                            # 绑定本机1051端口
        except:
            print "bind is error"
        server.listen(1)                            # 开始监听
        self.lt = ListenThread(self.win,server)                # 创建监听线程对象
        self.lt.setDaemon(True)
        self.lt.start()                                # 执行监听线程
        self.event.wait()                            # 进入等待状态
        server.close()                                # 关闭连接
        print "server is closed"
    def stop(self):                                    # 结束控制进程
        self.event.set()                            # 设置event标志

class TestPopup(wx.PopupWindow):
    """Adds a bit of text and mouse movement to the wx.PopupWindow"""
    def __init__(self, parent, style,message):
        wx.PopupWindow.__init__(self, parent, style)
        self.SetBackgroundColour("CADET BLUE")
        try:
            st = wx.StaticText(self, -1, message, pos=(10,10))
        except:
            st = wx.StaticText(self, -1, "本条信息没有正常解析！", pos=(10,10))

        sz = st.GetBestSize()
        self.SetSize( (sz.width+20, sz.height+20) )

        self.Bind(wx.EVT_LEFT_DOWN, self.OnMouseLeftDown)
        self.Bind(wx.EVT_MOTION, self.OnMouseMotion)
        self.Bind(wx.EVT_LEFT_UP, self.OnMouseLeftUp)
        self.Bind(wx.EVT_RIGHT_UP, self.OnRightUp)

        st.Bind(wx.EVT_LEFT_DOWN, self.OnMouseLeftDown)
        st.Bind(wx.EVT_MOTION, self.OnMouseMotion)
        st.Bind(wx.EVT_LEFT_UP, self.OnMouseLeftUp)
        st.Bind(wx.EVT_RIGHT_UP, self.OnRightUp)

        wx.CallAfter(self.Refresh)

    def OnMouseLeftDown(self, evt):
        self.Refresh()
        self.ldPos = evt.GetEventObject().ClientToScreen(evt.GetPosition())
        self.wPos = self.ClientToScreen((0,0))
        self.CaptureMouse()

    def OnMouseMotion(self, evt):
        if evt.Dragging() and evt.LeftIsDown():
            dPos = evt.GetEventObject().ClientToScreen(evt.GetPosition())
            nPos = (self.wPos.x + (dPos.x - self.ldPos.x),
                    self.wPos.y + (dPos.y - self.ldPos.y))
            self.Move(nPos)

    def OnMouseLeftUp(self, evt):
        self.ReleaseMouse()

    def OnRightUp(self, evt):
        self.Show(False)
        self.Destroy()


class Frame(wx.Frame):
    frameshow = False
    poplist =[]
    def __init__(self, parent, id, title):
        wx.Frame.__init__(self, parent, id, title,
                (100,100),(200,200),style =wx.DEFAULT_FRAME_STYLE | wx.FRAME_TOOL_WINDOW)
        panel = wx.Panel(self)
        button = wx.Button(panel,label="开始监听",pos=(25,10),size =(150,50))
        self.Bind(wx.EVT_BUTTON, self.Listen, button)
        button2 = wx.Button(panel,label="退出",pos=(25,110),size =(150,50))
        self.Bind(wx.EVT_BUTTON, self.OnQuit, button2)
        self.event = wx.CommandEvent(wx.wxEVT_COMMAND_BUTTON_CLICKED, button2.GetId())
        self.tbicon = wx.TaskBarIcon()
        bmp = ico.getyicoBitmap()
        icon = wx.IconFromBitmap(bmp)
        self.tbicon.SetIcon(icon, '')
        wx.EVT_TASKBAR_LEFT_UP(self.tbicon, self.OnShowFrame)
        wx.EVT_TASKBAR_RIGHT_UP(self.tbicon, self.OnClearPop)
        
        self.Bind(EVT_UPDATE_BARGRAPH, self.OnChangeText) # 创建线程信息到达信号
        self.ctrl = Control(self)                        # 创建控制线程对象
        self.ctrl.setDaemon(True)
        self.ctrl.start()                            # 执行控制线程

    def OnClearPop(self,evt):                       # 清除所有提示窗口 

        print self.poplist
        print len(self.poplist)
        for i in range(len(self.poplist)):
            pop=self.poplist.pop()
            pop.Show(False)
            pop.Destroy()

    def ShowPopup(self,message):                    # 显示提示窗口
        ss = []
        for i in range(0,(len(message)/30)+1):
            ts = message[i*30:i*30+29]+'\n'
            ss.extend(ts)
        self.message = ''.join(ss)
        self.win = TestPopup(self, wx.SIMPLE_BORDER,self.message)
        self.win.Position((0,0), (1200, 25))
        self.win.Show(True)
        self.poplist.append(self.win)


    def OnShowFrame(self, evt):                     # 显示或者隐藏窗口
        self.frameshow = not self.frameshow
        self.Show(self.frameshow)

    def OnQuit(self, evt):
        self.ctrl.stop()                            # 结束控制线程
        self.Close(True)
        wx.GetApp().ProcessIdle()

    def OnChangeText(self, evt):
        global RtxMessage
        if RtxMessage <> "":
            self.ShowPopup(RtxMessage)
            RtxMessage =""

    def Listen(self, evt):                                # 处理按钮事件
        self.ctrl = Control(self)                        # 创建控制线程对象
        self.ctrl.setDaemon(True)
        self.ctrl.start()                            # 执行控制线程

class App(wx.App):

    def OnInit(self):
        self.frame = Frame(parent=None, id=-1, title='RTX监控')  #创建框架
        self.frame.Show(False)
        self.SetTopWindow(self.frame)
        return True


if __name__ == '__main__':
    controlrun = True
    lock = threading.RLock()
    RtxMessage="未收到信息"
    app = App() 
    app.MainLoop()  # 进入主事件循环
